local myMod = ...

-- Register all shoemaker building parts and their properties
myMod:dofile("scripts/building_settings.lua")

local myBuilding =
{
	DataType = "BUILDING",
	Id = "SHOEMAKER_BUILDING",
	Name = "SHOEMAKER_NAME",
	Description = "SHOEMAKER_DESC",
	BuildingType = "GENERAL",
	VillagerRequired = { Status = "COMMONER", Quantity = 20 }
}
--Check which version is been used
if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
	myBuilding.BuildingPartSetList = {
		{
			Name = "GENERAL",
			BuildingPartList = { "SHOEMAKER_PART" }
		}
	}
	_DefinitionOfBuildingZone = {
		Polygon = polygon.createRectangle({ 10, 7 })
	}
else
	myBuilding.AssetCoreBuildingPart = "SHOEMAKER_PART"
	_DefinitionOfBuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {10, 7} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	}
end
 
myMod:register(myBuilding)

myMod:register({
	DataType = "BUILDING_PART",
	Id = "SHOEMAKER_PART",
	--Description = "",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SHOEMAKER"
	},
	BuildingZone = _DefinitionOfBuildingZone,
	--BuildingZoneData = {
	--	Polygon = polygon.createRectangle({ 10, 7 })
	--},
	ConstructionVisual = "PREFAB_SHOEMAKER_CONSTRUCTION",
	--DesirabilityModifiers = {"DESIRABILITY_EFFECT_TYPE"},
	BuildingFunction = "SHOEMAKER_FUNCTION",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 5 }
		},
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 10 },
			{ Resource = "PLANK", Quantity = 6 },
			{ Resource = "TOOL", Quantity = 4 }
		}
	}
})
 
-- Building function
myMod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "SHOEMAKER_FUNCTION",
    WorkerCapacity = 2,
	RelatedJob = { Job = "SHOEMAKER", Behavior = "WORK_BEHAVIOR" },
	InputInventoryCapacity = {{ Resource = "LEATHER", Quantity = 20 }},
	ResourceListNeeded = {{ Resource = "LEATHER", Quantity = 4 }},
	ResourceProduced = {{ Resource = "SHOES", Quantity = 2 }}	
})